"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.factory = void 0;
const typescript_1 = __importDefault(require("typescript"));
const semver_1 = __importDefault(require("semver"));
const originalFactory = typescript_1.default.factory;
function createImportSpecifier(propertyName, name) {
    if (semver_1.default.satisfies(typescript_1.default.version, '>= 4.5'))
        // @ts-ignore
        return originalFactory.createImportSpecifier(false, propertyName, name);
    // @ts-ignore
    return originalFactory.createImportSpecifier(propertyName, name);
}
function createExportSpecifier(propertyName, name) {
    if (semver_1.default.satisfies(typescript_1.default.version, '>= 4.5'))
        // @ts-ignore
        return originalFactory.createExportSpecifier(false, propertyName, name);
    // @ts-ignore
    return originalFactory.createExportSpecifier(propertyName, name);
}
exports.factory = {
    ...originalFactory,
    createImportSpecifier,
    createExportSpecifier,
};
//# sourceMappingURL=factory.js.map